Index: orxonox/trunk/doc/orxodox.src
===================================================================
--- orxonox/trunk/doc/orxodox.src	(revision 3364)
+++ orxonox/trunk/doc/orxodox.src	(revision 3365)
@@ -7,5 +7,5 @@
 PROJECT_NAME           = Orxonox
 PROJECT_NUMBER         = 1
-OUTPUT_DIRECTORY       = doc/doxygen/
+OUTPUT_DIRECTORY       = doxygen/
 CREATE_SUBDIRS         = YES
 OUTPUT_LANGUAGE        = English
@@ -34,6 +34,6 @@
 #---------------------------------------------------------------------------
 EXTRACT_ALL            = NO
-EXTRACT_PRIVATE        = NO
-EXTRACT_STATIC         = NO
+EXTRACT_PRIVATE        = YES
+EXTRACT_STATIC         = YES
 EXTRACT_LOCAL_CLASSES  = YES
 EXTRACT_LOCAL_METHODS  = NO
@@ -69,7 +69,7 @@
 # configuration options related to the input files
 #---------------------------------------------------------------------------
-INPUT                  = src/
+INPUT                  = .
 FILE_PATTERNS          = 
-RECURSIVE              = YES
+RECURSIVE              = NO
 EXCLUDE                = 
 EXCLUDE_SYMLINKS       = NO
Index: orxonox/trunk/src/Makefile.am
===================================================================
--- orxonox/trunk/src/Makefile.am	(revision 3364)
+++ orxonox/trunk/src/Makefile.am	(revision 3365)
@@ -24,9 +24,18 @@
 		 story_entity.cc \
 		 environment.cc \
-		 importer/object.cc \
+		 importer/model.cc \
 		 importer/array.cc \
 		 importer/material.cc \
+		 importer/texture.cc \
 		 list.cc \
-		 p_node.cc
+		 p_node.cc \
+		 null_parent.cc \
+		 base_object.cc \
+		 helper_parent.cc \
+		 track_manager.cc \
+		 matrix.cc \
+		 curve.cc \
+		 glmenu_imagescreen.cc
+
 
 noinst_HEADERS = ability.h \
@@ -54,5 +63,4 @@
 		 shoot_laser.h \
 		 world_entity.h \
-		 coordinates.h \
 		 message_structures.h \
 		 shoot_rocket.h \
@@ -62,5 +70,13 @@
 		 game_loader.h \
 		 campaign.h \
-		 p_node.h
+		 p_node.h \
+		 null_parent.h \
+		 base_object.h \
+		 helper_parent.h \
+		 track_manager.h \
+		 matrix.h \
+		 curve.h \
+		 glmenu_imagescreen.h
+
 
 ## orxonox.conf will be used from home-dir instead.
Index: orxonox/trunk/src/base_object.cc
===================================================================
--- orxonox/trunk/src/base_object.cc	(revision 3365)
+++ orxonox/trunk/src/base_object.cc	(revision 3365)
@@ -0,0 +1,48 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+
+#include "base_object.h"
+
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+*/
+BaseObject::BaseObject () {}
+
+
+/**
+   \brief standard deconstructor
+*/
+BaseObject::~BaseObject () {}
+
+
+void BaseObject::setClassName (char* className)
+{
+  this->className = className;
+}
+
+
+bool BaseObject::isA (char* className)
+{
+  if( this->className == className)
+    return false;
+  return true;
+}
Index: orxonox/trunk/src/base_object.h
===================================================================
--- orxonox/trunk/src/base_object.h	(revision 3365)
+++ orxonox/trunk/src/base_object.h	(revision 3365)
@@ -0,0 +1,27 @@
+/*! 
+    \file proto_class.h
+    \brief Definition of the proto class template, used quickly start work
+*/
+
+
+#ifndef _BASE_OBJECT_H
+#define _BASE_OBJECT_H
+
+#include "stdincl.h"
+
+
+class BaseObject {
+
+ public:
+  BaseObject ();
+  ~BaseObject ();
+
+  void setClassName (char* className);
+  bool isA (char* className);
+
+ private:
+  char* className;
+
+};
+
+#endif /* _BASE_OBJECT_H */
Index: orxonox/trunk/src/camera.cc
===================================================================
--- orxonox/trunk/src/camera.cc	(revision 3364)
+++ orxonox/trunk/src/camera.cc	(revision 3365)
@@ -42,7 +42,6 @@
   this->t = 0.0;
 
-  this->actualPlace.r.x = 0.0;
-  this->actualPlace.r.y = 10.0;
-  this->actualPlace.r.z = -5.0;
+
+  this->setDrawable (false);
 }
 
@@ -67,5 +66,5 @@
   //printf("time is: t=%f\n", t );
   updateDesiredPlace();
-  jump(NULL);
+  //jump(NULL);
 }
 
@@ -83,4 +82,5 @@
     case ELLIPTICAL:
       {
+	/*
 	//r = actual_place.r 
 	Orxonox *orx = Orxonox::getInstance();
@@ -95,5 +95,4 @@
 	      {
 		Vector *start = new Vector(0.0, 1.0, 0.0);
-		//r = /*actual_place.r*/ *start - plFocus.r;
 		r = *(new Vector(0.0, 5.0, 0.0));
 
@@ -120,37 +119,24 @@
 	    //printf("vector r = %f, %f, %f\n",r.x, r.y, r.z );
 	    rAbs = r.len();
-	    if(t < 30.0) /* FIXME!!*/
+	    if(t < 30)
 	      {
 		ka = rAbs / deltaTime*deltaTime;
 	      }
-	    /* this is the new length of the vector */
-	    //float len = ka * powf((deltaTime - t), 2);
-	    
-	    /* calc the rotation */
-	    /*
-	    Vector axis(0.0, 0.0, 1.0);
-	    if(t < 30.0)
-	      a0 = PI/4 - atanf(fabs(r.x) / fabs(r.y));
-	    printf("a0 = %f\n", a0);
-	    float angle = a0/deltaTime * (deltaTime - t);
-	    printf("angle is: %f\n", angle);
-	    Quaternion q(angle, axis);
-	    */
-	    //r = q.apply(r);
-	    //r = r * (len/r.len());
-	    
-	    //res->quatSlerp(from, to, t/deltaTime, res);
+
 	    res->quatSlerp(to, from, t/deltaTime, res);
 
 	    Vector ursp(0.0, 0.0, 0.0);
-	    desiredPlace.r = /*plFocus.r -*/ ursp - res->apply(r); 
+	    desiredPlace.r =  ursp - res->apply(r); 
 
 	    printf("desired place is: %f, %f, %f\n", desiredPlace.r.x, desiredPlace.r.y, desiredPlace.r.z);
 	    //plLastBPlace = *bound->get_placement();
+	    
 	  } 
+      */
       }
       break;
     case SMOTH_FOLLOW:
       {
+	/*
 	Placement *plBound = bound->getPlacement();
 	Location lcBound;
@@ -160,6 +146,7 @@
 	    Vector vDirection(0.0, 0.0, 1.0);
 	    vDirection = plBound->w.apply(vDirection);
-	    desiredPlace.r = (vDirection * ((lcBound.dist-10.0)/* / l*/)) + Vector(0,0,5.0);
+	    desiredPlace.r = (vDirection * ((lcBound.dist-10.0))) + Vector(0,0,5.0);
 	  }
+	*/
 	break;
       }
@@ -167,4 +154,5 @@
     case STICKY:
       {
+	/*
 	if(bound != null)
 	  {
@@ -175,18 +163,21 @@
 	    desiredPlace.r = plBound->r - vDirection*10 + eclipticOffset;
 	  }
+	*/
 	break;
       }
       /* the camera is handled like an entity and rolls on the track */
     case NORMAL:
-      Location lookat;  
       if( bound != NULL && world != NULL )
 	{
-	  bound->getLookat (&lookat);
-	  world->calcCameraPos (&lookat, &desiredPlace);
+	  //FIXME: camera should be made via relative coordinates
+	  Vector* cameraOffset = new Vector (-10, 5, 0);
+	  this->setRelCoor (cameraOffset);
 	} 
       else
 	{
+	  /*
 	  desiredPlace.r = Vector (0,0,0);
 	  desiredPlace.w = Quaternion (); 
+	  */
 	}
       break;
@@ -237,17 +228,18 @@
   // rotation
   float matrix[4][4];
-  actualPlace.w.conjugate().matrix (matrix);
+  //this->absDirection.conjugate().matrix (matrix);
   /* orientation and */
-  glMultMatrixf ((float*)matrix);
+  //glMultMatrixf ((float*)matrix);
+
   /*  translation */
-  glTranslatef (-actualPlace.r.x, -actualPlace.r.y,- actualPlace.r.z);
-//Placement *plBound = bound->get_placement();
+  //glTranslatef (this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z );
+
 
   // ===== second camera control calculation option
-  /*
-   gluLookAt(actual_place.r.x, actual_place.r.y, actual_place.r.z, 
-              plBound->r.x, plBound->r.y, plBound->r.z,
-              0.0, 0.0, 1.0);
-  */
+  
+  gluLookAt(this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z, 
+	    this->parent->getAbsCoor ().x, this->parent->getAbsCoor ().y, this->parent->getAbsCoor ().z,
+	    0.0, 1.0, 0.0);
+  
 
   glMatrixMode (GL_MODELVIEW);
@@ -255,23 +247,5 @@
 }
 
-/**
-  \brief set the camera position
-  \param plc: The Placement to set the camera to 
-	
-	This will set the actual and desired placement of the camera to plc
-*/
-void Camera::jump (Placement* plc = NULL)
-{
-  if( plc == NULL)
-    {
-      actualPlace = desiredPlace;
-      //printf("Camera|jump: camer@ %f, %f, %f\n\n", actual_place.r.x, actual_place.r.y, actual_place.r.z);
-    }
-  else
-    {
-      desiredPlace = *plc;
-      actualPlace = *plc;
-    }
-}
+
 
 /**
Index: orxonox/trunk/src/camera.h
===================================================================
--- orxonox/trunk/src/camera.h	(revision 3364)
+++ orxonox/trunk/src/camera.h	(revision 3365)
@@ -8,6 +8,7 @@
 
 #include "stdincl.h"
+#include "world_entity.h"
 
-class WorldEntity;
+
 class World;
 
@@ -23,9 +24,7 @@
 enum CAMERA_MODE {NORMAL, SMOTH_FOLLOW, STICKY, ELLIPTICAL};
 
-class Camera {
+class Camera : public WorldEntity {
  private:
   WorldEntity* bound;		//!< the WorldEntity the Camera is bound to
-  Placement actualPlace;	        //!< the Camera's current position
-  Placement desiredPlace;        //!< where the Camera should be according to calculations
   World* world;
   
@@ -37,5 +36,4 @@
   
   /* elliptical camera mode variables */
-  Placement plLastBPlace;
   float cameraOffset;
   float cameraOffsetZ;
@@ -63,5 +61,4 @@
   void apply ();
   void bind (WorldEntity* entity);
-  void jump (Placement* plc);
   void destroy();
 
Index: orxonox/trunk/src/curve.cc
===================================================================
--- orxonox/trunk/src/curve.cc	(revision 3364)
+++ orxonox/trunk/src/curve.cc	(revision 3365)
@@ -11,9 +11,11 @@
    ### File Specific:
    main-programmer: Benjamin Grauer
-   co-programmer: ...
+   co-programmer: Patrick Boenzli
+
+   ADD: Patrick Boenzli           B-Spline 
+
 
    TODO: 
      local-Time implementation
-     closed Bezier Curve
      NURBS
      
@@ -21,6 +23,9 @@
 
 #include "curve.h"
-
-
+#include "matrix.h"
+#include "debug.h"
+
+#include <math.h>
+#include <stdio.h>
 
 /**
@@ -37,7 +42,26 @@
   currentNode->next = 0; // not sure if this really points to NULL!!
   currentNode->number = (++nodeCount);
+  this->rebuild();
   return;
 }
 
+/**
+   \brief Finds a Node by its Number, and returns its Position
+   \param nodeToFind the n'th node in the List of nodes
+   \returns A Vector to the Position of the Node.
+*/
+Vector Curve::getNode(unsigned int nodeToFind)
+{
+  if (nodeToFind > this->nodeCount)
+    return Vector(0,0,0);
+  PathNode* tmpNode = this->firstNode;
+  for (int i = 1; i < nodeToFind; i++)
+    tmpNode = tmpNode->next;
+  return tmpNode->position;
+}
+
+///////////////////////////////////
+/// Bezier Curve //////////////////
+///////////////////////////////////
 
 /**
@@ -45,4 +69,43 @@
 */
 BezierCurve::BezierCurve (void)
+{
+  this->derivation = 0;
+  dirCurve = new BezierCurve(1);
+  this->init();
+}
+
+/**
+   \brief Creates a new BezierCurve-Derivation-Curve
+*/
+BezierCurve::BezierCurve (int derivation)
+{
+  this->derivation = derivation;
+  dirCurve=NULL;
+  this->init();
+}
+
+/**
+   \brief Deletes a BezierCurve.
+
+   It does this by freeing all the space taken over from the nodes
+*/
+BezierCurve::~BezierCurve(void)
+{
+  PathNode* tmpNode;
+  currentNode = firstNode;
+  while (tmpNode != 0)
+    {
+      tmpNode = currentNode;
+      currentNode = currentNode->next;
+      delete tmpNode;
+    }
+  if (dirCurve)
+    delete dirCurve;
+}
+
+/**
+   \brief Initializes a BezierCurve
+*/
+void BezierCurve::init(void)
 {
   nodeCount = 0;
@@ -58,9 +121,135 @@
 
 /**
-   \brief Deletes a BezierCurve.
+   \brief Rebuilds a Curve
+*/
+void BezierCurve::rebuild(void)
+{
+  PathNode* tmpNode = firstNode;
+
+  // rebuilding the Curve itself
+  float k=0;
+  float n = nodeCount -1;
+  float binCoef = 1;
+  while(tmpNode)
+    {
+      tmpNode->factor = binCoef;
+      if (tmpNode =tmpNode->next)
+	{
+	  binCoef *=(n-k)/(k+1);
+	  ++k;
+	}
+    }
+
+  // rebuilding the Derivation curve
+  if(this->derivation == 0)
+    {
+      tmpNode = firstNode;
+      delete dirCurve;
+      dirCurve = new BezierCurve(1);
+      while(tmpNode->next)
+	{
+	  Vector tmpVector = (tmpNode->next->position)- (tmpNode->position);
+	  tmpVector.x*=(float)nodeCount;
+	  tmpVector.y*=(float)nodeCount;
+	  tmpVector.z*=(float)nodeCount;
+	  tmpVector.normalize();
+	  this->dirCurve->addNode(tmpVector);
+	  tmpNode = tmpNode->next;
+	}
+    }
+}
+
+/**
+   \brief calculates the Position on the curve
+   \param t The position on the Curve (0<=t<=1)
+   \return the Position on the Path
+*/
+Vector BezierCurve::calcPos(float t) 
+{
+  Vector ret = Vector(0.0,0.0,0.0);
+  if (this->nodeCount >= 3)
+    {
+      PathNode* tmpNode = this->firstNode;
+      double factor = pow(1.0-t,nodeCount-1);
+      while(tmpNode)
+	{
+	  ret.x += tmpNode->factor * factor * tmpNode->position.x;
+	  ret.y += tmpNode->factor * factor * tmpNode->position.y;
+	  ret.z += tmpNode->factor * factor * tmpNode->position.z;
+	  factor *= t/(1.0-t); // same as pow but much faster.
+	  
+	  tmpNode = tmpNode->next;
+	}
+    }
+  else if (nodeCount == 2)
+    {
+      ret = this->firstNode->position *(1.0-t);
+      ret = ret + this->firstNode->next->position * t;
+    }
+  else if (nodeCount == 1)
+    ret = this->firstNode->position;
+  return ret;
+}
+
+/**
+   \brief Calulates the direction of the Curve at time t.
+   \param The time at which to evaluate the curve.
+   \returns The vvaluated Vector.
+*/
+Vector BezierCurve::calcDir (float t)
+{
+  return dirCurve->calcPos(t);
+}
+
+/**
+   \brief Calculates the Quaternion needed for our rotations
+   \param t The time at which to evaluate the cuve.
+   \returns The evaluated Quaternion.
+*/
+Quaternion BezierCurve::calcQuat (float t)
+{
+  return Quaternion (calcDir(t), Vector(0,0,1));
+}
+
+
+/**
+  \brief returns the Position of the point calculated on the Curve
+  \return a Vector to the calculated position
+*/
+Vector BezierCurve::getPos(void) const
+{
+  return curvePoint;
+}
+
+
+
+///////////////////////////////////
+//// Uniform Point curve  /////////
+///////////////////////////////////
+/**
+   \brief Creates a new UPointCurve
+*/
+UPointCurve::UPointCurve (void)
+{
+  this->derivation = 0;
+  this->init();
+}
+
+/**
+   \brief Creates a new UPointCurve-Derivation-Curve of deriavation'th degree
+*/
+UPointCurve::UPointCurve (int derivation)
+{
+  this->derivation = derivation;
+  dirCurve=NULL;
+  this->init();
+}
+
+/**
+   \brief Deletes a UPointCurve.
 
    It does this by freeing all the space taken over from the nodes
 */
-BezierCurve::~BezierCurve (void)
+UPointCurve::~UPointCurve(void)
 {
   PathNode* tmpNode;
@@ -72,4 +261,69 @@
       delete tmpNode;
     }
+  if (dirCurve)
+    delete dirCurve;
+}
+
+/**
+   \brief Initializes a UPointCurve
+*/
+void UPointCurve::init(void)
+{
+  nodeCount = 0;
+  firstNode = new PathNode;
+  currentNode = firstNode;
+
+  firstNode->position = Vector (.0, .0, .0);
+  firstNode->number = 0;
+  firstNode->next = 0; // not sure if this really points to NULL!!
+
+  return;
+}
+
+/**
+   \brief Rebuilds a UPointCurve
+   
+   \todo very bad algorithm
+*/
+void UPointCurve::rebuild(void)
+{
+  // rebuilding the Curve itself
+  PathNode* tmpNode = this->firstNode;
+  int i=0;
+  Matrix xTmpMat = Matrix(this->nodeCount, this->nodeCount);
+  Matrix yTmpMat = Matrix(this->nodeCount, this->nodeCount);
+  Matrix zTmpMat = Matrix(this->nodeCount, this->nodeCount);
+  Matrix xValMat = Matrix(this->nodeCount, 3);
+  Matrix yValMat = Matrix(this->nodeCount, 3);
+  Matrix zValMat = Matrix(this->nodeCount, 3);
+  while(tmpNode)
+    {
+      Vector fac = Vector(1,1,1);
+      for (int j = 0; j < this->nodeCount; j++)
+	{
+	  xTmpMat(i,j) = fac.x; fac.x *= (float)i/(float)this->nodeCount;//tmpNode->position.x;
+	  yTmpMat(i,j) = fac.y; fac.y *= (float)i/(float)this->nodeCount;//tmpNode->position.y;
+	  zTmpMat(i,j) = fac.z; fac.z *= (float)i/(float)this->nodeCount;//tmpNode->position.z;
+	}
+      xValMat(i,0) = tmpNode->position.x;
+      yValMat(i,0) = tmpNode->position.y;
+      zValMat(i,0) = tmpNode->position.z;
+      ++i;
+      tmpNode = tmpNode->next;
+    }
+  tmpNode = this->firstNode;
+  xValMat = xTmpMat.Inv() *= xValMat;
+  yValMat = yTmpMat.Inv() *= yValMat;
+  zValMat = zTmpMat.Inv() *= zValMat;
+  i = 0;
+  while(tmpNode)
+    {
+      tmpNode->vFactor.x = xValMat(i,0);
+      tmpNode->vFactor.y = yValMat(i,0);
+      tmpNode->vFactor.z = zValMat(i,0);
+
+      i++;
+      tmpNode = tmpNode->next;
+    }
 }
 
@@ -79,32 +333,17 @@
    \return the Position on the Path
 */
-Vector BezierCurve::calcPos(float t) 
-{
-  if (nodeCount <=4)
-    {
-      //      if (verbose >= 1)
-      //      printf ("Please define at least 4 nodes, until now you have only defined %i.\n", nodeCount);
-      return Vector(0,0,0);
-    }
+Vector UPointCurve::calcPos(float t) 
+{
   PathNode* tmpNode = firstNode;
-    
   Vector ret = Vector(0.0,0.0,0.0);
-  double factor;
-  int k=0;
-  while(tmpNode!=0)
-    {
-      k++;
-      factor = ncr (nodeCount, k);
-      
-      for (int j=0; j<nodeCount-k; j++)
-	factor*=(1-t);
-      for (int j=0; j<k; j++)
-	factor*=t;
-      ret.x += factor * tmpNode->position.x;
-      ret.y += factor * tmpNode->position.y;
-      ret.z += factor * tmpNode->position.z;
-      
+  float factor = 1.0;
+  while(tmpNode)
+    {
+      ret.x += tmpNode->vFactor.x * factor;
+      ret.y += tmpNode->vFactor.y * factor;
+      ret.z += tmpNode->vFactor.z * factor;
+      factor *= t;
+
       tmpNode = tmpNode->next;
-
     }
   return ret;
@@ -116,24 +355,20 @@
    \returns The vvaluated Vector.
 */
-Vector BezierCurve::calcDir (float t)
+Vector UPointCurve::calcDir (float t)
 {
   PathNode* tmpNode = firstNode;
-  BezierCurve* tmpCurve = new BezierCurve();
-  Vector ret;
-  Vector tmpVector;
-
-  while (tmpNode->next != 0)
-    {
-      tmpVector = (tmpNode->next->position)- (tmpNode->position);
-      tmpVector.x*=(float)nodeCount;
-      tmpVector.y*=(float)nodeCount;
-      tmpVector.z*=(float)nodeCount;
-
-      tmpCurve->addNode(tmpVector);
+  Vector ret = Vector(0.0,0.0,0.0);
+  float factor = 1.0/t;
+  int k=0;
+  while(tmpNode)
+    {
+      ret.x += tmpNode->vFactor.x * factor *k;
+      ret.y += tmpNode->vFactor.y * factor *k;
+      ret.z += tmpNode->vFactor.z * factor *k;
+      factor *= t;
+      k++;
       tmpNode = tmpNode->next;
     }
-  ret = tmpCurve->calcPos(t);
   ret.normalize();
-
   return ret;
 }
@@ -144,5 +379,5 @@
    \returns The evaluated Quaternion.
 */
-Quaternion BezierCurve::calcQuat (float t)
+Quaternion UPointCurve::calcQuat (float t)
 {
   return Quaternion (calcDir(t), Vector(0,0,1));
@@ -154,24 +389,6 @@
   \return a Vector to the calculated position
 */
-Vector BezierCurve::getPos() const
+Vector UPointCurve::getPos(void) const
 {
   return curvePoint;
 }
-
-/**
-   \brief ncr-calculator, did not find an other method
-   \todo a c++ variante to do this
-*/
-int ncr(int n, int i)
-{
-  int ret = 1;
-  for (int k=1; k<=n; k++)
-    ret*=k;
-  for (int k=1; k<=i; k++)
-    ret/=k;
-  for (int k=1; k<=n-i; k++)
-    ret/=k;
-
-  return ret;
-}
-
Index: orxonox/trunk/src/curve.h
===================================================================
--- orxonox/trunk/src/curve.h	(revision 3364)
+++ orxonox/trunk/src/curve.h	(revision 3365)
@@ -1,2 +1,3 @@
+
 /*! 
     \file curve.h
@@ -11,6 +12,9 @@
 #include "vector.h"
 
+//! An Enumerator that defines what sort of Curves are availible
+enum CurveType {BEZIERCURVE, UPOINTCURVE};
 
-//! An abstract class to handle curves.
+
+//! An abstract class to handle curves. Needed for the Tracking system in orxonox.
 class Curve
 {
@@ -19,4 +23,6 @@
   Vector curvePoint;     //!< The point on the Cureve at a local Time.
   float localTime;       //!< If the time of one point is asked more than once the programm will not calculate it again.
+  Curve* dirCurve;       //!< The derivation-curve of this Curve.
+  int derivation;        //!< Which derivation of a Curve is this.
 
   //! Handles the curve-points (dynamic List)
@@ -24,4 +30,6 @@
   {
     int number;          //!< The N-th node of this curve.
+    float factor;        //!< Curve specific multiplier factor.
+    Vector vFactor;      //!< A Vector-factor for multipliing.
     Vector position;     //!< Vector Pointung to this curve-point.
     PathNode* next;      //!< Pointer to the next Node.
@@ -31,32 +39,74 @@
   PathNode* currentNode; //!< The node we are working with (the Last node).
 
+ private:
+  virtual void rebuild(void) = 0;
  public:
-  void addNode (const Vector& newNode);
+  void addNode(const Vector& newNode);
+  Vector getNode(unsigned int nodeToFind);
+  inline int getNodeCount(void) { return this->nodeCount;}
 
+  virtual Vector calcPos(float t) = 0;
+  virtual Vector calcDir(float t) = 0;
+  virtual Quaternion calcQuat(float t) = 0;
+ 
 };
 
-//! Bezier Curve
+//!    Class to handle bezier curves in 3-dimesnsional space
 /**
-   Class to handle bezier curves in 3-dimesnsional space
-   
-   needed for  the Tracking system in OrxOnoX.
+   This Curve is good, for Fast Interaction. If you want to change it during the game, go on.
+   !!be aware!! BezierCurves only flow through their first and last Node. Their Tangents at those Points a directed to the second and second-last Point.
 */
 class BezierCurve : public Curve
 {
  private:
-  // all from Curve-Class
+  void rebuild(void);
  public:
-  BezierCurve (void);
-  ~BezierCurve (void);
-  Vector calcPos (float t);
-  Vector calcDir (float t);
-  Quaternion calcQuat (float t);
+  BezierCurve(void);
+  BezierCurve(int derivation);
+  ~BezierCurve(void);
+  void init(void);
+
+  Vector calcPos(float t);
+  Vector calcDir(float t);
+  Quaternion calcQuat(float t);
   
   
-  Vector getPos () const;
+  Vector getPos(void) const;
 };
 
-int ncr(int n, int i);
+
+//! B-Spline
+/**
+   class to handle b-spline in 3d space
+*/
+class BSplieCurve : public Curve
+{
 
 
+};
+
+//! Uniform Point Curve-class
+/**
+   A UPoint Curve is a A Curve, that flows through all the nodes given it.
+   The Algorithm to buid the curve is rather slow, but Painting and tracing along the curve has high speed, so do not change this curve during the Game.
+
+   This Curve is very erattic, so i do not recommend to use it.
+*/
+class UPointCurve : public Curve
+{
+ private:
+  void rebuild(void);
+ public:
+  UPointCurve(void);
+  UPointCurve(int derivation);
+  ~UPointCurve(void);
+  void init(void);
+
+  Vector calcPos(float t);
+  Vector calcDir(float t);
+  Quaternion calcQuat(float t);
+  
+  Vector getPos(void) const;
+};
+
 #endif /* _CURVE_H */
Index: orxonox/trunk/src/data_tank.cc
===================================================================
--- orxonox/trunk/src/data_tank.cc	(revision 3364)
+++ orxonox/trunk/src/data_tank.cc	(revision 3365)
@@ -19,4 +19,6 @@
 using namespace std;
 
+long DataTank::timeStamp = 0;
+
 DataTank::DataTank () {}
 DataTank::~DataTank () {}
Index: orxonox/trunk/src/data_tank.h
===================================================================
--- orxonox/trunk/src/data_tank.h	(revision 3364)
+++ orxonox/trunk/src/data_tank.h	(revision 3365)
@@ -10,4 +10,6 @@
   ~DataTank ();
 
+  static long timeStamp;
+
 };
 
Index: orxonox/trunk/src/debug.h
===================================================================
--- orxonox/trunk/src/debug.h	(revision 3364)
+++ orxonox/trunk/src/debug.h	(revision 3365)
@@ -8,4 +8,5 @@
 
 #ifdef  DEBUG
+extern int verbose;
 #define PRINTF(x) \
            PRINTF ## x
Index: orxonox/trunk/src/environment.cc
===================================================================
--- orxonox/trunk/src/environment.cc	(revision 3364)
+++ orxonox/trunk/src/environment.cc	(revision 3365)
@@ -21,39 +21,21 @@
 #include "world_entity.h"
 #include "vector.h"
+#include "importer/model.h"
 
 using namespace std;
 
 
-//Sorry Bensch
-#define LEVEL_LENGTH 500
 
 Environment::Environment () : WorldEntity()
 {
-
-  /*
-  //Sorry Bensch: x,y = 10
-  for (int x = 0; x < 50; x++)
-    {
-      for (int y = 0; y < 50; y++)
-	{
-	  mountainTest[x][y] =0;
-	                                         
-	}
-    }
-  //Sorry Bensch: x,y = 9
-  for (int x = 1; x < LEVEL_LENGTH; x++)
-    {
-      for (int y = 1; y < LEVEL_LENGTH; y++)
-	{
-	  //mountainTest[x][y] = (float)random() / 900000000;
-	  mountainTest[x][y] = (float)(random() % 4);                                       
-	}
-    }
-  */
+  this->model = new Model("reaplow.obj");
 }
 
 
 
-Environment::~Environment () {}
+Environment::~Environment () 
+{
+  delete this->model;
+}
 
 void Environment::tick (float time) {}
@@ -71,70 +53,11 @@
   float matrix[4][4];
   
-  glTranslatef(getPlacement()->r.x,getPlacement()->r.y,getPlacement()->r.z);
-  getPlacement()->w.matrix (matrix);
-  glMultMatrixf ((float*)matrix);
-
-  glBegin(GL_TRIANGLES);
-  glColor3f(1,0,1);
-  glVertex3f(0,0,0.5);
-  glVertex3f(-0.5,0,-1);
-  glVertex3f(0.5,0,-1);
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  //rotate
+  this->getAbsDir ().matrix (matrix);
+  glMultMatrixf((float*)matrix);
   
-  glVertex3f(0,0,0.5);
-  glVertex3f(0,0.5,-1);
-  glVertex3f(0,-0.5,-1);
-  glEnd();
-    
-  glBegin(GL_QUADS);
-  glColor3f(1,0,1);
-  glVertex3f(0.5,0.5,-1);
-  glVertex3f(0.5,-0.5,-1);
-  glVertex3f(-0.5,-0.5,-1);
-  glVertex3f(-0.5,0.5,-1);
-  glEnd();
+  glMatrixMode(GL_MODELVIEW);
+  this->model->draw();
 }
 
-/*
-void Environment::paint()
-{
-  
-  glPushMatrix();
-  //glScalef(0.5, 0.5, 1.0);
-  //glTranslatef(xCor, yCor, zCor);
-  glTranslatef( -16.0, -2.0, 0.0);
-  
-  glColor3f(0.0, 1.0, 0.0);
-  
-  glBegin(GL_LINES);
-  for (int x = 0; x < LEVEL_LENGTH; x += 1)
-    {
-      for (int y = 0; y < 190; y += 1)
-	{
-	  glVertex3f((float)(2*x), (float)(2*y), mountainTest[x][y]);
-	  glVertex3f((float)(2*x), (float)(2*(y+1)), mountainTest[x][y+1]);
-	}
-    }
-  glEnd();
-  
-  
-  glBegin(GL_LINES);
-  for (int y = 0; y < LEVEL_LENGTH; y += 1)
-    {
-      for (int x = 0; x < 90; x += 1)
-	{
-	  glVertex3f((float)(2*x), (float)(2*y), mountainTest[x][y]);
-	  glVertex3f((float)(2*(x+1)), (float)(2*y), mountainTest[x+1][y]);
-	}
-    }
-  glEnd();
-  
-  glPopMatrix();
-  
-}
-
-void Environment::drawEnvironment() 
-{
-
-}
-
-*/
